=== modified file 'plugin/innobase/log/log0recv.cc'
--- plugin/innobase/log/log0recv.cc	2010-12-26 03:44:24 +0000
+++ plugin/innobase/log/log0recv.cc	2010-12-26 04:19:37 +0000
@@ -1405,7 +1405,7 @@
 			len = RECV_DATA_BLOCK_SIZE;
 		}
 
-		recv_data = static_cast<recv_addr_t *>(mem_heap_alloc(recv_sys->heap,
+		recv_data = static_cast<recv_data_t *>(mem_heap_alloc(recv_sys->heap,
 					   sizeof(recv_data_t) + len));
 		*prev_field = recv_data;
 

=== modified file 'plugin/innobase/page/page0page.cc'
--- plugin/innobase/page/page0page.cc	2010-12-26 03:44:24 +0000
+++ plugin/innobase/page/page0page.cc	2010-12-26 04:19:37 +0000
@@ -2315,6 +2315,7 @@
 	ulint		i= 0;
 	ulint*		offsets		= NULL;
 	ulint*		old_offsets	= NULL;
+        void* buf_ptr= NULL;
 
 	if (UNIV_UNLIKELY((ibool) !!page_is_comp(page)
 			  != dict_table_is_comp(index->table))) {
@@ -2336,7 +2337,7 @@
 	/* The following buffer is used to check that the
 	records in the page record heap do not overlap */
 
-        void *buf_ptr= mem_heap_zalloc(heap, UNIV_PAGE_SIZE);
+        buf_ptr= mem_heap_zalloc(heap, UNIV_PAGE_SIZE);
 	buf = static_cast<byte *>(buf_ptr);
 
 	/* Check first that the record heap and the directory do not

=== modified file 'plugin/innobase/pars/pars0opt.cc'
--- plugin/innobase/pars/pars0opt.cc	2010-12-24 00:04:05 +0000
+++ plugin/innobase/pars/pars0opt.cc	2010-12-26 04:19:37 +0000
@@ -96,7 +96,7 @@
 	ut_ad(exp && sel_node);
 
 	if (que_node_get_type(exp) == QUE_NODE_FUNC) {
-		func_node = exp;
+		func_node = static_cast<func_node_t *>(exp);
 
 		arg = func_node->args;
 
@@ -114,7 +114,7 @@
 
 	ut_a(que_node_get_type(exp) == QUE_NODE_SYMBOL);
 
-	sym_node = exp;
+	sym_node = static_cast<sym_node_t *>(exp);
 
 	if (sym_node->token_type != SYM_COLUMN) {
 
@@ -185,7 +185,7 @@
 	arg = search_cond->args;
 
 	if (que_node_get_type(arg) == QUE_NODE_SYMBOL) {
-		sym_node = arg;
+		sym_node = static_cast<sym_node_t *>(arg);
 
 		if ((sym_node->token_type == SYM_COLUMN)
 		    && (sym_node->table == table)
@@ -211,7 +211,7 @@
 	arg = que_node_get_next(arg);
 
 	if (que_node_get_type(arg) == QUE_NODE_SYMBOL) {
-		sym_node = arg;
+		sym_node = static_cast<sym_node_t *>(arg);
 
 		if ((sym_node->token_type == SYM_COLUMN)
 		    && (sym_node->table == table)
@@ -262,7 +262,7 @@
 	ut_a(search_cond->func != PARS_NOT_TOKEN);
 
 	if (search_cond->func == PARS_AND_TOKEN) {
-		new_cond = search_cond->args;
+		new_cond = static_cast<func_node_t *>(search_cond->args);
 
 		exp = opt_look_for_col_in_cond_before(cmp_type, col_no,
 						      new_cond, sel_node,
@@ -272,7 +272,7 @@
 			return(exp);
 		}
 
-		new_cond = que_node_get_next(new_cond);
+		new_cond = static_cast<func_node_t *>(que_node_get_next(new_cond));
 
 		exp = opt_look_for_col_in_cond_before(cmp_type, col_no,
 						      new_cond, sel_node,
@@ -329,7 +329,7 @@
 	ulint		goodness;
 	ulint		n_fields;
 	ulint		col_no;
-	ulint		op;
+	ulint		op= 0;
 	ulint		j;
 
 	goodness = 0;
@@ -346,7 +346,8 @@
 		col_no = dict_index_get_nth_col_no(index, j);
 
 		exp = opt_look_for_col_in_cond_before(
-			OPT_EQUAL, col_no, sel_node->search_cond,
+			OPT_EQUAL, col_no,
+                        static_cast<func_node_t *>(sel_node->search_cond),
 			sel_node, nth_table, &op);
 		if (exp) {
 			/* The value for this column is exactly known already
@@ -359,7 +360,7 @@
 			/* Look for non-equality comparisons */
 
 			exp = opt_look_for_col_in_cond_before(
-				OPT_COMPARISON, col_no, sel_node->search_cond,
+				OPT_COMPARISON, col_no, static_cast<func_node_t *>(sel_node->search_cond),
 				sel_node, nth_table, &op);
 			if (exp) {
 				index_plan[j] = exp;
@@ -583,8 +584,8 @@
 					    n_fields);
 		dict_index_copy_types(plan->tuple, plan->index, n_fields);
 
-		plan->tuple_exps = mem_heap_alloc(pars_sym_tab_global->heap,
-						  n_fields * sizeof(void*));
+		plan->tuple_exps = static_cast<void **>(mem_heap_alloc(pars_sym_tab_global->heap,
+						  n_fields * sizeof(void*)));
 
 		ut_memcpy(plan->tuple_exps, best_index_plan,
 			  n_fields * sizeof(void*));
@@ -726,11 +727,11 @@
 	}
 
 	if (cond->func == PARS_AND_TOKEN) {
-		new_cond = cond->args;
+		new_cond = static_cast<func_node_t *>(cond->args);
 
 		opt_find_test_conds(sel_node, i, new_cond);
 
-		new_cond = que_node_get_next(new_cond);
+		new_cond = static_cast<func_node_t *>(que_node_get_next(new_cond));
 
 		opt_find_test_conds(sel_node, i, new_cond);
 
@@ -772,7 +773,7 @@
 
 		if (que_node_get_type(arg2) == QUE_NODE_SYMBOL) {
 
-			sym_node = arg2;
+			sym_node = static_cast<sym_node_t *>(arg2);
 
 			if ((sym_node->token_type == SYM_COLUMN)
 			    && (sym_node->table == table)) {
@@ -812,7 +813,7 @@
 
 	/* Recursively go through the conjuncts and classify them */
 
-	opt_find_test_conds(sel_node, i, sel_node->search_cond);
+	opt_find_test_conds(sel_node, i, static_cast<func_node_t *>(sel_node->search_cond));
 
 	opt_normalize_cmp_conds(UT_LIST_GET_FIRST(plan->end_conds),
 				plan->table);
@@ -852,7 +853,7 @@
 	}
 
 	if (que_node_get_type(exp) == QUE_NODE_FUNC) {
-		func_node = exp;
+		func_node = static_cast<func_node_t *>(exp);
 
 		arg = func_node->args;
 
@@ -867,7 +868,7 @@
 
 	ut_a(que_node_get_type(exp) == QUE_NODE_SYMBOL);
 
-	sym_node = exp;
+	sym_node = static_cast<sym_node_t *>(exp);
 
 	if (sym_node->token_type != SYM_COLUMN) {
 
@@ -953,11 +954,11 @@
 	ut_ad(que_node_get_type(search_cond) == QUE_NODE_FUNC);
 
 	if (search_cond->func == PARS_AND_TOKEN) {
-		new_cond = search_cond->args;
+		new_cond = static_cast<func_node_t *>(search_cond->args);
 
 		opt_find_copy_cols(sel_node, i, new_cond);
 
-		new_cond = que_node_get_next(new_cond);
+		new_cond = static_cast<func_node_t *>(que_node_get_next(new_cond));
 
 		opt_find_copy_cols(sel_node, i, new_cond);
 
@@ -1012,7 +1013,7 @@
 		exp = que_node_get_next(exp);
 	}
 
-	opt_find_copy_cols(sel_node, i, sel_node->search_cond);
+	opt_find_copy_cols(sel_node, i, static_cast<func_node_t *>(sel_node->search_cond));
 
 	/* All remaining columns in the search condition are temporary
 	columns: therefore FALSE */
@@ -1068,7 +1069,7 @@
 
 	dict_index_copy_types(plan->clust_ref, clust_index, n_fields);
 
-	plan->clust_map = mem_heap_alloc(heap, n_fields * sizeof(ulint));
+	plan->clust_map = static_cast<unsigned long *>(mem_heap_alloc(heap, n_fields * sizeof(ulint)));
 
 	for (i = 0; i < n_fields; i++) {
 		pos = dict_index_get_nth_field_pos(index, clust_index, i);
@@ -1108,8 +1109,8 @@
 	order_node_t*	order_by;
 	ulint		i;
 
-	sel_node->plans = mem_heap_alloc(pars_sym_tab_global->heap,
-					 sel_node->n_tables * sizeof(plan_t));
+	sel_node->plans = static_cast<plan_t *>(mem_heap_alloc(pars_sym_tab_global->heap,
+					 sel_node->n_tables * sizeof(plan_t)));
 
 	/* Analyze the search condition to find out what we know at each
 	join stage about the conditions that the columns of a table should
@@ -1138,7 +1139,7 @@
 
 		opt_determine_and_normalize_test_conds(sel_node, i);
 
-		table_node = que_node_get_next(table_node);
+		table_node = static_cast<sym_node_t *>(que_node_get_next(table_node));
 	}
 
 	table_node = sel_node->table_list;
@@ -1155,7 +1156,7 @@
 
 		opt_clust_access(sel_node, i);
 
-		table_node = que_node_get_next(table_node);
+		table_node = static_cast<sym_node_t *>(que_node_get_next(table_node));
 	}
 
 	/* Check that the plan obeys a possible order-by clause: if not,

=== modified file 'plugin/innobase/pars/pars0pars.cc'
--- plugin/innobase/pars/pars0pars.cc	2010-12-24 02:12:29 +0000
+++ plugin/innobase/pars/pars0pars.cc	2010-12-26 04:19:37 +0000
@@ -156,7 +156,7 @@
 {
 	func_node_t*	node;
 
-	node = mem_heap_alloc(pars_sym_tab_global->heap, sizeof(func_node_t));
+	node = static_cast<func_node_t *>(mem_heap_alloc(pars_sym_tab_global->heap, sizeof(func_node_t)));
 
 	node->common.type = QUE_NODE_FUNC;
 	dfield_set_data(&(node->common.val), NULL, 0);
@@ -219,7 +219,7 @@
 {
 	order_node_t*	node;
 
-	node = mem_heap_alloc(pars_sym_tab_global->heap, sizeof(order_node_t));
+	node = static_cast<order_node_t *>(mem_heap_alloc(pars_sym_tab_global->heap, sizeof(order_node_t)));
 
 	node->common.type = QUE_NODE_ORDER;
 
@@ -368,7 +368,7 @@
 	ut_a(exp_node);
 
 	if (que_node_get_type(exp_node) == QUE_NODE_FUNC) {
-		func_node = exp_node;
+		func_node = static_cast<func_node_t *>(exp_node);
 
 		arg = func_node->args;
 
@@ -385,7 +385,7 @@
 
 	ut_a(que_node_get_type(exp_node) == QUE_NODE_SYMBOL);
 
-	sym_node = exp_node;
+	sym_node = static_cast<sym_node_t *>(exp_node);
 
 	if (sym_node->resolved) {
 
@@ -476,7 +476,7 @@
 	ut_a(exp_node);
 
 	if (que_node_get_type(exp_node) == QUE_NODE_FUNC) {
-		func_node = exp_node;
+		func_node = static_cast<func_node_t *>(exp_node);
 
 		arg = func_node->args;
 
@@ -491,7 +491,7 @@
 
 	ut_a(que_node_get_type(exp_node) == QUE_NODE_SYMBOL);
 
-	sym_node = exp_node;
+	sym_node = static_cast<sym_node_t *>(exp_node);
 
 	if (sym_node->resolved) {
 
@@ -533,7 +533,7 @@
 			}
 		}
 
-		t_node = que_node_get_next(t_node);
+		t_node = static_cast<sym_node_t *>(que_node_get_next(t_node));
 	}
 }
 
@@ -598,7 +598,7 @@
 
 		count++;
 
-		sym_node = que_node_get_next(sym_node);
+		sym_node = static_cast<sym_node_t *>(que_node_get_next(sym_node));
 	}
 
 	return(count);
@@ -637,7 +637,7 @@
 				select_node->select_list, col_node);
 		}
 
-		table_node = que_node_get_next(table_node);
+		table_node = static_cast<sym_node_t *>(que_node_get_next(table_node));
 	}
 }
 
@@ -687,7 +687,7 @@
 
 		if (que_node_get_type(exp_node) == QUE_NODE_FUNC) {
 
-			func_node = exp_node;
+			func_node = static_cast<func_node_t *>(exp_node);
 
 			if (func_node->func_class == PARS_FUNC_AGGREGATE) {
 
@@ -867,8 +867,8 @@
 {
 	col_assign_node_t*	node;
 
-	node = mem_heap_alloc(pars_sym_tab_global->heap,
-			      sizeof(col_assign_node_t));
+	node = static_cast<col_assign_mode_t *>(mem_heap_alloc(pars_sym_tab_global->heap,
+			      sizeof(col_assign_node_t)));
 	node->common.type = QUE_NODE_COL_ASSIGNMENT;
 
 	node->col = column;
@@ -897,7 +897,7 @@
 	ulint			i;
 
 	table_sym = node->table_sym;
-	col_assign_list = node->col_assign_list;
+	col_assign_list = static_cast<col_assign_node_t *>(node->col_assign_list);
 	clust_index = dict_table_get_first_index(node->table);
 
 	assign_node = col_assign_list;
@@ -923,7 +923,7 @@
 				  assign_node->val);
 		n_assigns++;
 
-		assign_node = que_node_get_next(assign_node);
+		assign_node = static_cast<col_assign_node_t *>(que_node_get_next(assign_node));
 	}
 
 	node->update = upd_create(n_assigns, pars_sym_tab_global->heap);
@@ -949,7 +949,7 @@
 			changes_field_size = 0;
 		}
 
-		assign_node = que_node_get_next(assign_node);
+		assign_node = static_cast<col_assign_node_t *>(que_node_get_next(assign_node));
 	}
 
 	/* Find out if the update can modify an ordering field in any index */
@@ -1212,12 +1212,12 @@
 {
 	que_common_t*	common;
 
-	common = node_list;
+	common = static_cast<que_common_t *>(node_list);
 
 	while (common) {
 		common->parent = parent;
 
-		common = que_node_get_next(common);
+		common = static_cast<que_common_t>(que_node_get_next(common));
 	}
 }
 
@@ -1233,7 +1233,7 @@
 {
 	elsif_node_t*	node;
 
-	node = mem_heap_alloc(pars_sym_tab_global->heap, sizeof(elsif_node_t));
+	node = static_cast<elsif_node_t *>(mem_heap_alloc(pars_sym_tab_global->heap, sizeof(elsif_node_t)));
 
 	node->common.type = QUE_NODE_ELSIF;
 
@@ -1261,7 +1261,7 @@
 	if_node_t*	node;
 	elsif_node_t*	elsif_node;
 
-	node = mem_heap_alloc(pars_sym_tab_global->heap, sizeof(if_node_t));
+	node = static_cast<if_node_t *>(mem_heap_alloc(pars_sym_tab_global->heap, sizeof(if_node_t)));
 
 	node->common.type = QUE_NODE_IF;
 
@@ -1276,14 +1276,14 @@
 		/* There is a list of elsif conditions */
 
 		node->else_part = NULL;
-		node->elsif_list = else_part;
+		node->elsif_list = static_cast<elsif_node_t>(else_part);
 
-		elsif_node = else_part;
+		elsif_node = static_cast<elsif_node_t *>(else_part);
 
 		while (elsif_node) {
 			pars_set_parent_in_list(elsif_node->stat_list, node);
 
-			elsif_node = que_node_get_next(elsif_node);
+			elsif_node = static_cast<elsif_node_t *>(que_node_get_next(elsif_node));
 		}
 	} else {
 		node->else_part = else_part;
@@ -1309,7 +1309,7 @@
 {
 	while_node_t*	node;
 
-	node = mem_heap_alloc(pars_sym_tab_global->heap, sizeof(while_node_t));
+	node = static_cast<while_node_t *>(mem_heap_alloc(pars_sym_tab_global->heap, sizeof(while_node_t)));
 
 	node->common.type = QUE_NODE_WHILE;
 
@@ -1338,7 +1338,7 @@
 {
 	for_node_t*	node;
 
-	node = mem_heap_alloc(pars_sym_tab_global->heap, sizeof(for_node_t));
+	node = static_cast<for_node_t *>(mem_heap_alloc(pars_sym_tab_global->heap, sizeof(for_node_t)));
 
 	node->common.type = QUE_NODE_FOR;
 
@@ -1370,7 +1370,7 @@
 {
 	exit_node_t*	node;
 
-	node = mem_heap_alloc(pars_sym_tab_global->heap, sizeof(exit_node_t));
+	node = static_cast<exit_node_t *>(mem_heap_alloc(pars_sym_tab_global->heap, sizeof(exit_node_t)));
 	node->common.type = QUE_NODE_EXIT;
 
 	return(node);
@@ -1386,8 +1386,8 @@
 {
 	return_node_t*	node;
 
-	node = mem_heap_alloc(pars_sym_tab_global->heap,
-			      sizeof(return_node_t));
+	node = static_cast<return_node_t *>(mem_heap_alloc(pars_sym_tab_global->heap,
+			      sizeof(return_node_t)));
 	node->common.type = QUE_NODE_RETURN;
 
 	return(node);

=== modified file 'plugin/innobase/pars/pars0sym.cc'
--- plugin/innobase/pars/pars0sym.cc	2010-12-24 02:12:29 +0000
+++ plugin/innobase/pars/pars0sym.cc	2010-12-26 04:19:37 +0000
@@ -52,7 +52,7 @@
 {
 	sym_tab_t*	sym_tab;
 
-	sym_tab = mem_heap_alloc(heap, sizeof(sym_tab_t));
+	sym_tab = static_cast<sym_tab_t *>(mem_heap_alloc(heap, sizeof(sym_tab_t)));
 
 	UT_LIST_INIT(sym_tab->sym_list);
 	UT_LIST_INIT(sym_tab->func_node_list);
@@ -116,7 +116,7 @@
 	sym_node_t*	node;
 	byte*		data;
 
-	node = mem_heap_alloc(sym_tab->heap, sizeof(sym_node_t));
+	node = static_cast<sym_node_t *>(mem_heap_alloc(sym_tab->heap, sizeof(sym_node_t)));
 
 	node->common.type = QUE_NODE_SYMBOL;
 
@@ -127,7 +127,7 @@
 
 	dtype_set(dfield_get_type(&node->common.val), DATA_INT, 0, 4);
 
-	data = mem_heap_alloc(sym_tab->heap, 4);
+	data = static_cast<byte *>(mem_heap_alloc(sym_tab->heap, 4));
 	mach_write_to_4(data, val);
 
 	dfield_set_data(&(node->common.val), data, 4);
@@ -161,7 +161,7 @@
 	sym_node_t*	node;
 	byte*		data;
 
-	node = mem_heap_alloc(sym_tab->heap, sizeof(sym_node_t));
+	node = static_cast<sym_node_t *>(mem_heap_alloc(sym_tab->heap, sizeof(sym_node_t)));
 
 	node->common.type = QUE_NODE_SYMBOL;
 
@@ -174,7 +174,7 @@
 		  DATA_VARCHAR, DATA_ENGLISH, 0);
 
 	if (len) {
-		data = mem_heap_alloc(sym_tab->heap, len);
+		data = static_cast<byte *>(mem_heap_alloc(sym_tab->heap, len));
 		ut_memcpy(data, str, len);
 	} else {
 		data = NULL;
@@ -214,7 +214,7 @@
 	blit = pars_info_get_bound_lit(sym_tab->info, name);
 	ut_a(blit);
 
-	node = mem_heap_alloc(sym_tab->heap, sizeof(sym_node_t));
+	node = static_cast<sym_node_t *>(mem_heap_alloc(sym_tab->heap, sizeof(sym_node_t)));
 
 	node->common.type = QUE_NODE_SYMBOL;
 
@@ -286,7 +286,7 @@
 {
 	sym_node_t*	node;
 
-	node = mem_heap_alloc(sym_tab->heap, sizeof(sym_node_t));
+	node = static_cast<sym_node_t *>(mem_heap_alloc(sym_tab->heap, sizeof(sym_node_t)));
 
 	node->common.type = QUE_NODE_SYMBOL;
 
@@ -326,7 +326,7 @@
 {
 	sym_node_t*	node;
 
-	node = mem_heap_alloc(sym_tab->heap, sizeof(sym_node_t));
+	node = static_cast<sym_node_t *>(mem_heap_alloc(sym_tab->heap, sizeof(sym_node_t)));
 
 	node->common.type = QUE_NODE_SYMBOL;
 
@@ -368,7 +368,7 @@
 	bid = pars_info_get_bound_id(sym_tab->info, name);
 	ut_a(bid);
 
-	node = mem_heap_alloc(sym_tab->heap, sizeof(sym_node_t));
+	node = static_cast<sym_node_t *>(mem_heap_alloc(sym_tab->heap, sizeof(sym_node_t)));
 
 	node->common.type = QUE_NODE_SYMBOL;
 

=== modified file 'plugin/innobase/que/que0que.cc'
--- plugin/innobase/que/que0que.cc	2010-12-24 00:04:05 +0000
+++ plugin/innobase/que/que0que.cc	2010-12-26 04:19:37 +0000
@@ -166,7 +166,7 @@
 
 	ut_ad(heap);
 
-	fork = mem_heap_alloc(heap, sizeof(que_fork_t));
+	fork = static_cast<que_fork_t *>(mem_heap_alloc(heap, sizeof(que_fork_t)));
 
 	fork->common.type = QUE_NODE_FORK;
 	fork->n_active_thrs = 0;
@@ -208,7 +208,7 @@
 
 	ut_ad(parent && heap);
 
-	thr = mem_heap_alloc(heap, sizeof(que_thr_t));
+	thr = static_cast<que_thr_t *>(mem_heap_alloc(heap, sizeof(que_thr_t)));
 
 	thr->common.type = QUE_NODE_THR;
 	thr->common.parent = parent;
@@ -527,7 +527,7 @@
 	switch (que_node_get_type(node)) {
 
 	case QUE_NODE_FORK:
-		fork = node;
+		fork = static_cast<que_fork_t *>(node);
 
 		thr = UT_LIST_GET_FIRST(fork->thrs);
 
@@ -540,7 +540,7 @@
 		break;
 	case QUE_NODE_THR:
 
-		thr = node;
+		thr = static_cast<que_fork_t *>(node);
 
 		if (thr->magic_n != QUE_THR_MAGIC_N) {
 			fprintf(stderr,
@@ -558,21 +558,21 @@
 		break;
 	case QUE_NODE_UNDO:
 
-		undo = node;
+		undo = static_cast<undo_node_tr *>(node);
 
 		mem_heap_free(undo->heap);
 
 		break;
 	case QUE_NODE_SELECT:
 
-		sel = node;
+		sel = static_cast<sel_node_t *>(node);
 
 		sel_node_free_private(sel);
 
 		break;
 	case QUE_NODE_INSERT:
 
-		ins = node;
+		ins = static_cast<ins_node_t *>(node);
 
 		que_graph_free_recursive(ins->select);
 
@@ -580,7 +580,7 @@
 
 		break;
 	case QUE_NODE_PURGE:
-		purge = node;
+		purge = static_cast<purge_node_t *>(node);
 
 		mem_heap_free(purge->heap);
 
@@ -588,7 +588,7 @@
 
 	case QUE_NODE_UPDATE:
 
-		upd = node;
+		upd = static_cast<upd_node_t *>(node);
 
 		if (upd->in_mysql_interface) {
 
@@ -607,7 +607,7 @@
 
 		break;
 	case QUE_NODE_CREATE_TABLE:
-		cre_tab = node;
+		cre_tab = static_cast<tab_node_t *>(node);
 
 		que_graph_free_recursive(cre_tab->tab_def);
 		que_graph_free_recursive(cre_tab->col_def);
@@ -617,7 +617,7 @@
 
 		break;
 	case QUE_NODE_CREATE_INDEX:
-		cre_ind = node;
+		cre_ind = static_cast<ind_node_t *>(node);
 
 		que_graph_free_recursive(cre_ind->ind_def);
 		que_graph_free_recursive(cre_ind->field_def);
@@ -799,7 +799,7 @@
 	ulint		fork_type;
 	ibool		stopped;
 
-	fork = thr->common.parent;
+	fork = static_cast<que_fork_t *>(thr->common.parent);
 	trx = thr_get_trx(thr);
 
 	mutex_enter(&kernel_mutex);

=== modified file 'plugin/innobase/rem/rem0rec.cc'
--- plugin/innobase/rem/rem0rec.cc	2010-12-24 00:04:05 +0000
+++ plugin/innobase/rem/rem0rec.cc	2010-12-26 04:19:37 +0000
@@ -578,7 +578,7 @@
 						     MEM_HEAP_DYNAMIC,
 						     file, line);
 		}
-		offsets = mem_heap_alloc(*heap, size * sizeof(ulint));
+		offsets = static_cast<unsigned long *>(mem_heap_alloc(*heap, size * sizeof(ulint)));
 		rec_offs_set_n_alloc(offsets, size);
 	}
 
@@ -1362,7 +1362,7 @@
 			mem_free(*buf);
 		}
 
-		*buf = mem_alloc2(prefix_len, buf_size);
+		*buf = static_cast<byte *>(mem_alloc2(prefix_len, buf_size));
 	}
 
 	ut_memcpy(*buf, rec - area_start, prefix_len);
@@ -1488,7 +1488,7 @@
 			mem_free(*buf);
 		}
 
-		*buf = mem_alloc2(prefix_len, buf_size);
+		*buf = static_cast<byte *>(mem_alloc2(prefix_len, buf_size));
 	}
 
 	memcpy(*buf, lens + 1, prefix_len);

